// MVSMp3PlayerDlg.cpp : implementation file
//

#include "stdafx.h"
#include "MVSMp3Player.h"
#include "MVSMp3PlayerDlg.h"
#include "MyHyperLink.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	CMyHyperLink m_myLink;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
	m_myLink.SetLinkUrl("http://activex.moonvalley.com");
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	DDX_Control(pDX, IDC_Link, m_myLink);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMVSMp3PlayerDlg dialog

CMVSMp3PlayerDlg::CMVSMp3PlayerDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMVSMp3PlayerDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CMVSMp3PlayerDlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CMVSMp3PlayerDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMVSMp3PlayerDlg)
	DDX_Control(pDX, IDC_SLIDER2, m_position);
	DDX_Control(pDX, IDC_SLIDER1, m_volume);
	DDX_Control(pDX, IDC_Link, m_MVSButton);
	DDX_Control(pDX, IDC_BUTTON8, m_open);
	DDX_Control(pDX, IDC_BUTTON7, m_mute);
	DDX_Control(pDX, IDC_BUTTON6, m_forward);
	DDX_Control(pDX, IDC_BUTTON5, m_stop);
	DDX_Control(pDX, IDC_BUTTON4, m_pause);
	DDX_Control(pDX, IDC_BUTTON3, m_play);
	DDX_Control(pDX, IDC_BUTTON2, m_rewind);
	DDX_Control(pDX, IDC_EDIT2, m_edtSong);
	DDX_Control(pDX, IDC_EDIT1, m_edtArtist);
	DDX_Control(pDX, IDC_MP3PCTRL1, m_mp3Ctrl);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CMVSMp3PlayerDlg, CDialog)
	//{{AFX_MSG_MAP(CMVSMp3PlayerDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON6, OnForward)
	ON_BN_CLICKED(IDC_BUTTON2, OnRewind)
	ON_BN_CLICKED(IDC_BUTTON3, OnPlay)
	ON_BN_CLICKED(IDC_BUTTON4, OnPause)
	ON_BN_CLICKED(IDC_BUTTON5, OnStop)
	ON_BN_CLICKED(IDC_BUTTON8, OnOpen)
	ON_NOTIFY(NM_RELEASEDCAPTURE, IDC_SLIDER1, OnReleasedVolume)
	ON_NOTIFY(NM_RELEASEDCAPTURE, IDC_SLIDER2, OnReleasedPosition)
	ON_BN_CLICKED(IDC_BUTTON7, OnMute)
	ON_BN_CLICKED(IDC_Link, OnLink)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMVSMp3PlayerDlg message handlers

BOOL CMVSMp3PlayerDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	m_MVSButton.LoadBitmap(IDB_BITMAP1);

	m_edtArtist.SetReadOnly(true);
	m_edtSong.SetReadOnly(true);

	m_volume.SetPos(50);
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CMVSMp3PlayerDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CMVSMp3PlayerDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CMVSMp3PlayerDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CMVSMp3PlayerDlg::OnForward() 
{
	int amount = (m_mp3Ctrl.GetPositionRange() * 5) / 100;

	m_mp3Ctrl.Seek(m_mp3Ctrl.GetPosition() + amount, m_mp3Ctrl.GetPositionRange());
}

void CMVSMp3PlayerDlg::OnRewind() 
{
	int amount = (m_mp3Ctrl.GetPositionRange() * 5) / 100;
	
	m_mp3Ctrl.Seek(m_mp3Ctrl.GetPosition() - amount, m_mp3Ctrl.GetPositionRange());
}

void CMVSMp3PlayerDlg::OnPlay() 
{
	m_mp3Ctrl.Play();	
}

void CMVSMp3PlayerDlg::OnPause() 
{
	static bool pauseFlag;

	if (pauseFlag == true)
	{
		m_mp3Ctrl.Play();
		pauseFlag = !pauseFlag;
	}
	else
	{
		m_mp3Ctrl.Pause();
		pauseFlag = !pauseFlag;
	}
}

void CMVSMp3PlayerDlg::OnStop() 
{
	m_mp3Ctrl.Stop();
	m_position.SetPos(0);
}

void CMVSMp3PlayerDlg::OnOpen() 
{
	CFileDialog dlg(true, ".mp3", NULL, OFN_EXPLORER |OFN_HIDEREADONLY, "Mp3 Files (*.mp3)|*.mp3|All Files (*.*)|*.*||", this);	

	if (dlg.DoModal() == IDOK)
		m_mp3Ctrl.InputOpen(dlg.GetPathName());

	m_mp3Ctrl.Play();
}

BEGIN_EVENTSINK_MAP(CMVSMp3PlayerDlg, CDialog)
    //{{AFX_EVENTSINK_MAP(CMVSMp3PlayerDlg)
	ON_EVENT(CMVSMp3PlayerDlg, IDC_MP3PCTRL1, 7 /* InputPos */, OnInputPosMp3pctrl1, VTS_I4 VTS_I4)
	ON_EVENT(CMVSMp3PlayerDlg, IDC_MP3PCTRL1, 1 /* Ready */, OnReadyMp3pctrl1, VTS_NONE)
	//}}AFX_EVENTSINK_MAP
END_EVENTSINK_MAP()

void CMVSMp3PlayerDlg::OnInputPosMp3pctrl1(long position, long range) 
{
		m_position.SetRange(0, range, true);
		m_position.SetPos(position);
		m_edtArtist.SetWindowText(m_mp3Ctrl.GetTagInfo(1));
		m_edtSong.SetWindowText(m_mp3Ctrl.GetTagInfo(0));
}

void CMVSMp3PlayerDlg::OnReleasedVolume(NMHDR* pNMHDR, LRESULT* pResult) 
{
	int pos = m_volume.GetPos();
	m_mp3Ctrl.Volume(50, 50, pos);
	
	*pResult = 0;
}

void CMVSMp3PlayerDlg::OnReleasedPosition(NMHDR* pNMHDR, LRESULT* pResult) 
{
	int pos = m_position.GetPos();
	m_mp3Ctrl.Seek(pos, m_mp3Ctrl.GetPositionRange());
	
	*pResult = 0;
}

void CMVSMp3PlayerDlg::OnReadyMp3pctrl1() 
{
	m_edtArtist.SetWindowText(m_mp3Ctrl.GetTagInfo(1));
	m_edtSong.SetWindowText(m_mp3Ctrl.GetTagInfo(0));
}

void CMVSMp3PlayerDlg::OnMute() 
{
	static bool muteFlag;
	
	if (muteFlag == true)
	{
		m_mp3Ctrl.OutputMute();
		muteFlag = !muteFlag;
	}
	else
	{
		m_mp3Ctrl.OutputUnmute();
		muteFlag = !muteFlag;
	}
}

void CMVSMp3PlayerDlg::OnLink() 
{
	ShellExecute(NULL, "open", "http://activex.moonvalley.com", "", NULL, SW_SHOWNORMAL);	
}
